#include <eigen3/Eigen/Dense>
#include <cmath>
#include <iostream>
#include <iomanip>
#include <functional>
#include <vector>



//! \brief One step of SDIRK method for first order ode z' = f(z). Steps of size h.
//! \tparam StateType type of solution space z and initial data z0
//! \param[in] z0 initial data z(0)
//! \param[in] h size of the step
//! \param[in] gamma parameter
//! \return next step z1
////TASK E
template <class StateType>
StateType sdirkStep(const StateType & z0, double h, double gamma) {
    StateType z1;
    // TO-DO task (e):  implement one step of SDIRK method
    // ..
    // ..
    // ..
    return z1;
}
////END OF TASK E

//! \brief Use SDIRK method for first order ode z' = f(z), with N equidistant steps
//! \tparam StateType type of solution space z and initial data z0
//! \param[in] z0 initial data z(0)
//! \param[in] N number of equidistant steps
//! \param[in] T final time of simulation
//! \param[in] gamma parameter
//! \return vector containing each step of z_k
////TASK F
template <class StateType>
std::vector<StateType> sdirkSolve(const StateType & z0, unsigned int N, double T, double gamma) {
    // Solution vector
    std::vector<StateType> res(N+1);
    // TO-DO task (f): implement solution with SDIRK method
    // ..
    // ..
    // .. [continued within main()]
    return res;
}
////END OF TASK F

int main() {
    // Initial data z0
    Eigen::Vector2d z0;
    z0 << 1,0;
    // Final time
    const double T = 10;
    // TO-DO task (f) [continued]: Modify value of parameter gamma such that method is A-stable
    const double gamma = 1.0; //dummy
    // Mesh sizes
    std::vector<int> N = {20, 40, 80, 160, 320, 640, 1280, 2560, 5120, 10240};
    // Exact solution (only y(t)) given initial data  z0 and t
    auto yex = [&z0] (double t) {
        return 1./3.*std::exp(-t/2.) * ( 3.*z0(0) * std::cos( std::sqrt(3.)*t/2. ) + 
        std::sqrt(3.)*z0(0) * std::sin( std::sqrt(3.)*t/2. ) + 
        2.*std::sqrt(3.)*z0(1) * std::sin( std::sqrt(3.)*t/2. ) );
    };
    
    // TO-DO task (f) [continued]: Compute final solution for EACH mesh size and output observed order of convergence
    // ..
    // ..

}


// End of file
